map_ext = {
    'effe': 'effect',
    'lens': 'lens_flare',
    'prt3': 'particle',
    'LigS': 'lighting_settings',
    'sklt': 'sky_lighting',
    'fogg': 'atmosphere_fog',
    'cfxs': 'camera_fx_settings',
    'scgt': 'static_collision',
    'mat': 'material',
    'smet': 'structure_meta',
    'rtrn': 'runtime_terrain',
    'dcrt': 'runtime_dec',
    'tccg': 'terrain_cell_geo',
    'pfnd': 'pathfinding',
    'comp': 'composition',
    'subt': 'composer_subtracks',
    'Rani': 'runtimeanimset',
    'jmad': 'model_animation_graph',
    'rmbl': 'rumble',
    'camg': 'camera_animation_graph',
    'snd!': 'sound',
    'scen': 'scenery',
    'sndc': 'sound_category',
    'uslg': 'stringlist',
    'musc': 'music_control',
    'bloc': 'crate',
    'efge': 'generator_system',
    'hlmt': 'model',
    'phmo': 'physics_model',
    'mode': 'render_model',
    'coll': 'collision_model',
    'licn': 'light_cone',
    'xong': 'xobjectnodegraph',
    'ongc': 'objectnodegraph',
    'pmdf': 'particle_model',
    'gldf': 'cheap_light',
    'sefc': 'area_screen_effect',
    'bipd': 'biped',
    'ngst': 'node_graph_stack',
    'cusc': 'cui_screen',
    'snad': 'acousticsdata',
    'GobS': 'gobo_setting',
    'dcpt': 'decorator_palette',
    'dwsg': 'dynamicworldstateglobals',
    'sssc': 'scenario_sound_constants',
    'hscn': 'script_container',
    'hsc*': 'lua',
    'cnvo': 'conversation',
    'sddt': 'structure_design',
    'wind': 'wind',
    'stse': 'structure_seams',
    'hlds': 'hlodsystem',
    'sred': 'scenario_render_data',
    'frms': 'frame_event_list',
    'lsnd': 'sound_looping',
    'wcfg': 'weapon_configuration',
    'uiwi': 'uiweapondisplayinfodefinition',
    'sofd': 'framedefinition',
    'sofa': 'frameattachmentdefinition',
    'weab': 'weapon_attachment_barrel',
    'proj': 'projectile',
    'wett': 'weapon_attachment_target_tracking',
    'pmov': 'particle_physics',
    'decs': 'decal_system',
    'jpt!': 'damage_effect',
    'vcdd': 'vehicleconfiguration',
    'vehi': 'vehicle',
    'mwsy': 'materialstyles',
    'mwsw': 'materialswatch',
    'mwpl': 'materialpalette',
    'stai': 'sound_tail',
    'foot': 'material_effects',
    'weap': 'weapon',
    'desd': 'damage_effect_sounds',
    'trak': 'camera_track',
    'bost': 'unitboostdefinition',
    'cddf': 'collision_damage',
    'sadt': 'spring_acceleration',
    'drdf': 'damage_response_definition',
    'csdt': 'camera_shake',
    'uwfa': 'weaponframeattachment',
    'gmpm': 'genericmodifierdefinitiontag',
    'luas': 'lua_script',
    'ostd': 'outlinetypedefinition',
    'ctrl': 'device_control',
    'cmoe': 'camo',
    'udlg': 'dialogue',
    'prmr': 'projectilematerialresponse',
    'weam': 'weapon_attachment_magazine',
    'prjf': 'projectileflyby',
    'weme': 'weapon_attachment_melee',
    'eqip': 'equipment',
    'saev': 'evadedefinitiontag',
    'char': 'character',
    'styl': 'style',
    'beht': 'behaviortree',
    'west': 'weapon_attachment_sight',
    'mach': 'device_machine',
    'fpal': 'forgepalettedefinition',
    'ligr': 'lightgroup',
    'cwms': 'coatingmaterialset',
    'bdpd': 'death_program_selector',
    'ant!': 'antenna',
    'rwrd': 'render_water_ripple',
    'flck': 'flock',
    'crea': 'creature',
    'angt': 'xanimnodegraph',
    'ansm': 'xanimstategraph',
    'tlgt': 'xtransitionlogicgraph',
    'xbgt': 'xanimblendgraphng',
    'fele': 'frame_event_list_effect',
    'sidt': 'simulated_input',
    'cpem': 'cheap_particle_emitter',
    'ligh': 'light',
    'immo': 'ingamemapmaterialvariations',
    'mdsv': 'model_dissolve_definition',
    'maps': 'ingamemapsettings',
    'matg': 'globals',
    'trac': 'tracer_system',
    'grfr': 'grounded_friction',
    'ltvl': 'light_volume_system',
    'scbd': 'supercombine',
    'odok': 'dockingsitedefinition',
    'fanf': 'fanfaredefinition',
    'sdzg': 'scenario_required_resource',
    'ssdf': 'spawnsettings',
    'sgrp': 'sound_response',
    'wetr': 'weapon_attachment_trigger',
    'fela': 'frame_event_list_audio',
    'wdof': 'weapon_depth_of_field',
    'uivi': 'uivehicledisplayinfodefinition',
    'efwi': 'effect_wind',
    'egfd': 'effect_global_force',
    'vatc': 'vehicleattachment',
    'siin': 'simulation_interpolation',
    'weat': 'weapon_attachment',
    'shrs': 'shader_root_signature',
    'trds': 'trackdecalsystem',
    'intr': 'interaction',
    'ucnt': 'ucn_authority_trust_settings',
    'sagh': 'grapplehookdefinitiontag',
    'pugm': 'powerupdefinition',
    'sptp': 'spartantrackingpingdefinition',
    'cage': 'cagedefinition',
    'dsdt': 'dialogue_system_data',
    'gptd': 'game_performance_throttle',
    'curv': 'curvedefinition',
    'cnvt': 'conversationtypes',
    'spab': 'spartanabilitycomponentdefinition',
    'ghig': 'highlighteventsglobals',
    'texg': 'texturegroup',
    'embl': 'emblem',
    'shdr': 'shader',
    'toks': 'tokensystemglobalsdefinition',
    'mglb': 'meleeglobals',
    'narg': 'narrativeglobals',
    'gfpd': 'graphicspresetdefinitions',
    'ongg': 'objectnodegraph_globals',
    'phyg': 'physicsglobalsdefinition',
    'cmpg': 'campaignglobalsdefinition',
    'valu': 'valorunlocks',
    'cmpu': 'campaignupgrades',
    'uigm': 'gameplaymenuuiinfo',
    'cole': 'collectiblesdefinition',
    'chrd': 'chroma_definition',
    'chrm': 'chroma',
    'sngl': 'sound_globals',
    'aigl': 'ai_globals',
    'adlg': 'ai_dialogue_globals',
    'form': 'formation',
    'forg': 'forge_globals',
    'cmps': 'composition_scene',
    'gegl': 'game_engine_globals',
    'mulg': 'multiplayer_globals',
    'ssgd': 'spottingserviceglobals',
    'pnai': 'personalaiglobalsdefinition',
    'motl': 'multiplayer_object_type_list',
    'gggl': 'game_globals_grenade_list',
    'gmeg': 'game_medal_globals',
    'rasg': 'rasterizer_globals',
    'sspg': 'sssprofile',
    'perf': 'performance_throttles',
    'exs*': 'explicitshaders',
    'hair': 'hair',
    'efex': 'effect_exposure',
    'effg': 'effect_globals',
    'mfxg': 'materialeffectsglobals',
    'pmcg': 'player_model_customization_globals',
    'lgtd': 'loadout_globals_definition',
    'sggs': 'speechgrammarglobals',
    'cfdf': 'collisionfilterdefinition',
    'wgbl': 'weapon_globals',
    'glca': 'cameraglobalsdefinition',
    'glch': 'cheatglobalsdefinition',
    'glco': 'colorglobalsdefinition',
    'glcn': 'controlglobalsdefinition',
    'insc': 'inputscope',
    'inbu': 'inputbundle',
    'inmo': 'inputmode',
    'inbs': 'inputbundleset',
    'indb': 'inputdevicebindings',
    'glda': 'damageglobalsdefinition',
    'gldi': 'difficultyglobalsdefinition',
    'glso': 'softceilingglobalsdefinition',
    'glsk': 'skullglobalsdefinition',
    'glpa': 'playerglobalsdefinition',
    'glma': 'materialglobalsdefinition',
    'wpdp': 'water_physics_drag_properties',
    'gllo': 'locglobalsdefinition',
    'glin': 'interfaceglobalsdefinition',
    'caps': 'uicamerapresets',
    'fafl': 'forwardfastlighting',
    'uiin': 'uiiteminspect',
    'ltps': 'uilightpresets',
    'obcu': 'uiobjectcustomization',
    'plan': 'uiplatformanimations',
    'wigl': 'user_interface_shared_globals_definition',
    'bitd': 'bitmap_dictionary',
    'fnts': 'wpf_font_set',
    'dcgd': 'dispositioncolors',
    'fntf': 'typeface',
    'cure': 'cui_resources',
    'uise': 'user_interface_sounds_definition',
    'emth': 'emblem_theme_globals',
    'unic': 'multilingual_unicode_string_list',
    'nphg': 'narrationphonemes',
    'drdg': 'damagereportingdisplayglobals',
    'glga': 'garbagecollectionglobalsdefinition',
    'glgo': 'gameplayobjectglobalsdefinition',
    'glcm': 'composerglobalsdefinition',
    'glsa': 'skillrankingglobalsdefinition',
    'sptg': 'spartantrackingglobalsdefinition',
    'osgd': 'outlineserviceglobalsdefinition',
    'atcg': 'asset_category_globals',
    'nagl': 'navigationglobals',
    'glst': 'subtitleglobalsdefinition',
    'apdd': 'actionprioritydatadefinitiontag',
    'hsgd': 'highlightserviceglobalsdefinition',
    'cagg': 'cageglobalsdefinition',
    'attd': 'audiothreatglobals',
    'angb': 'animglobals',
    'bnch': 'benchmarkdefinition',
    'vart': 'vectorart',
    'flni': 'flinch_impulse',
    'cptl': 'cheap_particle_type_library',
    'ocad': 'customizationattachmentconfiguration',
    'font': 'wpf_font',
    'ocuv': 'customizationvehiclethemeconfiguration',
    'wgtz': 'user_interface_globals_definition',
    'ocuw': 'customizationweaponthemeconfiguration',
    'oceo': 'effectoverride',
    'sasp': 'sprintdefinitiontag',
    'pasd': 'uipersonalaisounds',
    'ocur': 'customizationthemeconfiguration',
    'oatd': 'objectattachmentsdefinition',
    'mwvs': 'materialvisorswatch',
    'phcc': 'clamberingdefinition',
    'pbfx': 'propertybasedeffectstag',
    'flns': 'flinch_system',
    'plcc': 'lowceilingcontroltag',
    'food': 'forgeobjectdata',
    'sumd': 'shieldupgrademetadata',
    'mead': 'meleeadditionaldamage',
    'ocgd': 'customizationglobalsdefinition',
    'walt': 'weaponcomponentaltfire',
    'trsd': 'uitransitionsounds',
    'uihg': 'user_interface_hud_globals_definition',
    'nvnm': 'navpointanimationgroup',
    'nvpt': 'navpointpresentation',
    'clwd': 'cloth',
    'botg': 'botglobalstag',
    'adrp': 'airdropsystemglobalsdefinition',
    'kit!': 'kit',
    'tvcm': 'trigger_volume_component',
    'pphs': 'physics_phantom_sounds',
    'snde': 'sound_environment',
    'uisd': 'uiseasondata',
    'cmpS': 'composer_spawning_pattern',
    'cmpt': 'composer_transition',
    'foom': 'forgeobjectmanifest',
    'rtmp': 'rtmp',
    'ftat': 'forgetelescopingasset',
    'foki': 'forgekit',
    'fosp': 'forgeobjectscriptpropertymenuitemdefinitions',
    'sirp': 'scenario_interpolator',
    'levl': 'level',
    'sbsp': 'scenario_structure_bsp',
    'bitm': 'bitmap',
    'sbnk': 'soundbank',
    'rtgo': 'runtime_geo',
    'stlm': 'structure_lightmap',
    'shdv': 'shadervariant',
    'shbc': 'shader_bytecode',
    'psod': 'psodictionary'
}

ma_guid_ext = {
    '868d0d7f83b900c5': 'effect',
    '4213e75fd9689b14': 'lens_flare',
    '4b776763b0dca880': 'particle',
    '477054c00a20e902': 'lighting_settings',
    '2c152e008d1e9137': 'sky_lighting',
    '00c246826af42683': 'atmosphere_fog',
    '7861c829a709afac': 'camera_fx_settings',
    '9635a5c26da9ae0f': 'static_collision',
    'c153bc7f8b97657f': 'material',
    '9b6f5cb7781aebe9': 'structure_meta',
    '4b84079e50bb2ee8': 'runtime_terrain',
    '6fde972c78aba2a9': 'runtime_dec',
    '024cf07d8e123b8e': 'terrain_cell_geo',
    'e7630bc8a9340583': 'pathfinding',
    'e2529e10d629f498': 'composition',
    '3f383fe80d9c3819': 'composer_subtracks',
    'da52924a7639673a': 'runtimeanimset',
    '4d584619acd60fa1': 'model_animation_graph',
    '41f1cff9a54ba6d9': 'rumble',
    '0c513df3cc2d3406': 'camera_animation_graph',
    '869da255ae340541': 'sound',
    '9f174bcb00e10516': 'scenery',
    'a2e07fee99584872': 'sound_category',
    'dd3f3a264a0996bd': 'stringlist',
    '7e0ece69ad3600f6': 'music_control',
    '1dc8e6a495da73aa': 'crate',
    '62ae322baf04c1ab': 'generator_system',
    '137249617a7e10c8': 'model',
    '3850bf893c60ba47': 'physics_model',
    '4bfc8b67894cb01e': 'render_model',
    '87a807c1998d5990': 'collision_model',
    'f0ca43cfbb7a64b9': 'light_cone',
    '9aa37b5924a2de1e': 'xobjectnodegraph',
    '9b4042a26195c1ef': 'objectnodegraph',
    'fcece08d8080db17': 'particle_model',
    '8a5e7bc8f7fe6f79': 'cheap_light',
    'd5922f495dc20249': 'area_screen_effect',
    '9493d9d91c9278cc': 'biped',
    'e68fd0667eeccfee': 'node_graph_stack',
    'e41542a069ef23ea': 'cui_screen',
    '7b8f81b76ad6d7c7': 'acousticsdata',
    '7759c73964d12a67': 'gobo_setting',
    'b8ff1223128724bf': 'decorator_palette',
    '81af088032e6d312': 'dynamicworldstateglobals',
    '12501eb4b996130b': 'scenario_sound_constants',
    '67cfe24b50511263': 'script_container',
    '1a913bd1f40ac78e': 'lua',
    '5f38ad80698564d5': 'conversation',
    '810e248004924b9a': 'structure_design',
    '1addd3b0cc65e4c2': 'wind',
    '1117c0973f7ad77c': 'structure_seams',
    '7e6b44492b3fbfd7': 'hlodsystem',
    '24914907e5f3dac0': 'scenario_render_data',
    '0d7904201467fd94': 'frame_event_list',
    'fa6b8a949b46b86c': 'sound_looping',
    'e18ad328a5b29c57': 'weapon_configuration',
    '576a10cf1b0003fb': 'uiweapondisplayinfodefinition',
    '84f8b5bb050281ec': 'framedefinition',
    'f0b17a6ab871c4d3': 'frameattachmentdefinition',
    'b37457453567966c': 'weapon_attachment_barrel',
    '70b6219f08f98bcd': 'projectile',
    'f558f79fb3831e5a': 'weapon_attachment_target_tracking',
    '2ff8f7acbe9ce894': 'particle_physics',
    '398ac03e3b9608e6': 'decal_system',
    '9a53011323baf81e': 'damage_effect',
    '6d6fd46c68243ccf': 'vehicleconfiguration',
    'c6fc7cc02e1d9624': 'vehicle',
    'b7ca7e055fc7aaf2': 'materialstyles',
    'b08a6aa7f7c5605a': 'materialswatch',
    '5c93498e91b677f1': 'materialpalette',
    'f28c10e6b4b238e3': 'sound_tail',
    'a3af770960ef5b25': 'material_effects',
    '9941e4f6e5ab3dbf': 'weapon',
    '5379b062bdaa0546': 'damage_effect_sounds',
    'ae759af988f234aa': 'camera_track',
    '7232de4b39033518': 'unitboostdefinition',
    'b7c570d23c0ea972': 'collision_damage',
    '19ffe4dec512ab91': 'spring_acceleration',
    '144aa412201f202a': 'damage_response_definition',
    '5cfa3671cfeb57d5': 'camera_shake',
    '7a081e746625fc33': 'weaponframeattachment',
    'f3fa0783c7790b4c': 'genericmodifierdefinitiontag',
    '01dd82945ff61375': 'lua_script',
    '89d932f3003e48b9': 'outlinetypedefinition',
    '2ff0ef203afbd8b9': 'device_control',
    'dbbb56b58b84cdaa': 'camo',
    'a29b845b50ae2682': 'dialogue',
    'ac51957e4eb9d79a': 'projectilematerialresponse',
    '7864e34df9cbbadc': 'weapon_attachment_magazine',
    '623e713b73efe169': 'projectileflyby',
    '61611671c0160e16': 'weapon_attachment_melee',
    '2087e0f1b5589b5e': 'equipment',
    'a4ee4bdd6421ebef': 'evadedefinitiontag',
    '90321165ee1dee18': 'character',
    '0ddbfce71dd023db': 'style',
    'cd5ecc1f4c7d644a': 'behaviortree',
    'ba6903ac036d4696': 'weapon_attachment_sight',
    'af95939c84e97748': 'device_machine',
    '9ddd10f4add5c3d8': 'forgepalettedefinition',
    '4092277f53927bb3': 'lightgroup',
    'faa285798d2fb97e': 'coatingmaterialset',
    '69a830ff68af1c69': 'death_program_selector',
    'edab80721831fdaa': 'antenna',
    '638e970939b72137': 'render_water_ripple',
    '2e308a001648139a': 'flock',
    '34e67334d08250a8': 'creature',
    '6e983176765acdf8': 'xanimnodegraph',
    '3cdc650eae06d492': 'xanimstategraph',
    'a22b0de828b24b1d': 'xtransitionlogicgraph',
    'f5d8d15fdb6a6ece': 'xanimblendgraphng',
    'd582b11cdd577146': 'frame_event_list_effect',
    'b8f3d1df2355bd08': 'simulated_input',
    '5307752b2f6b7dd9': 'cheap_particle_emitter',
    '3ee5b73fbbedff76': 'light',
    '1c48040f7ac5f800': 'ingamemapmaterialvariations',
    'c0fa3631d05cbc06': 'model_dissolve_definition',
    'ba3024085aafa120': 'ingamemapsettings',
    '2ba50b1d84185222': 'globals',
    '54e105f80fdf317b': 'tracer_system',
    'a1293c67f1a48a52': 'grounded_friction',
    'b4930a3a258d4047': 'light_volume_system',
    '4837c892ef68cf22': 'supercombine',
    '5fb1506921ee4be5': 'dockingsitedefinition',
    '97f286cbc563d5b8': 'fanfaredefinition',
    'd48744a7c36ad250': 'scenario_required_resource',
    'fdbce0607651a2d3': 'spawnsettings',
    'e34d46e3fac64452': 'sound_response',
    'b2ff511270b998f6': 'weapon_attachment_trigger',
    'c56442c982878240': 'frame_event_list_audio',
    'cc0e7f951d0d5e3b': 'weapon_depth_of_field',
    '67c003341b3c7866': 'uivehicledisplayinfodefinition',
    '23cfb305d66f319d': 'effect_wind',
    '47add5b06afcfc49': 'effect_global_force',
    '96a7776112202fd8': 'vehicleattachment',
    '72a4eb74d5d1d2fc': 'simulation_interpolation',
    '1fe39e6c7956f2ec': 'weapon_attachment',
    'c4e813ade91bd793': 'shader_root_signature',
    'b796f937f6a49605': 'trackdecalsystem',
    '2ae5aea2a160b34c': 'interaction',
    '70d577dbb7a068d9': 'ucn_authority_trust_settings',
    '841011a166c4b8fd': 'grapplehookdefinitiontag',
    'bd1ac890264df132': 'powerupdefinition',
    'f6d8dbe5b9112728': 'spartantrackingpingdefinition',
    '36e9d589b409cdcd': 'cagedefinition',
    '8162197842db6991': 'dialogue_system_data',
    'b53e9b2ff6c694ab': 'game_performance_throttle',
    '2280e474dcb66b4a': 'curvedefinition',
    '27e9404419014756': 'conversationtypes',
    'acc5b8baaee61e59': 'spartanabilitycomponentdefinition',
    '63ed4e2d22d90409': 'highlighteventsglobals',
    '3115d60f249a81a9': 'texturegroup',
    'a6413d9bb8ecc52a': 'emblem',
    'c1d48e8ef3e0be06': 'shader',
    'd58dcaaaddc2a8e2': 'tokensystemglobalsdefinition',
    'd0513ae60a4eac1b': 'meleeglobals',
    '49cf5366664b0b64': 'narrativeglobals',
    '0ce4cb051e9341b5': 'graphicspresetdefinitions',
    '17cbe9222337bdc6': 'objectnodegraph_globals',
    '9803134fbd40b92e': 'physicsglobalsdefinition',
    '94c1c53ecfb386e1': 'campaignglobalsdefinition',
    '9536e880ab6a18ad': 'valorunlocks',
    '0612c0054ea0e38f': 'campaignupgrades',
    'b8dbaa65fed9a431': 'gameplaymenuuiinfo',
    'fdd6e7a221026f1f': 'collectiblesdefinition',
    '1ced0992e64dd6c8': 'chroma_definition',
    'e056e6048526ceaf': 'chroma',
    '8a0d070ea81e7f9c': 'sound_globals',
    'e2c022838787ce7e': 'ai_globals',
    '7d5bd33774028e2e': 'ai_dialogue_globals',
    '8bdcaca0158f38ab': 'formation',
    '4a3e32463285f2d2': 'forge_globals',
    'b7faade5bbab8517': 'composition_scene',
    'cf8ba37345a76510': 'game_engine_globals',
    '4b83888b5e41e17a': 'multiplayer_globals',
    '5611441a4cc5b305': 'spottingserviceglobals',
    'e878553fa3c2e8c2': 'personalaiglobalsdefinition',
    '07c521ad525275c2': 'multiplayer_object_type_list',
    '73229d5f219615c7': 'game_globals_grenade_list',
    '19c6b852c21534f2': 'game_medal_globals',
    'c5a15caa2e5bcbd2': 'rasterizer_globals',
    'c3d39e22291b71ec': 'sssprofile',
    '9c2ae225713a6702': 'performance_throttles',
    'b8765f990ee0c4cf': 'explicitshaders',
    '3119eef85772b913': 'hair',
    '76298d6998f65f6b': 'effect_exposure',
    '4e6acc1eeeb9ce32': 'effect_globals',
    '4deae9de6d38d7de': 'materialeffectsglobals',
    '98db1c352c1fcbed': 'player_model_customization_globals',
    '10676c7ee7ea1756': 'loadout_globals_definition',
    'e3513be37ca33365': 'speechgrammarglobals',
    '163a537da64ecd00': 'collisionfilterdefinition',
    '298f76a08bab04b3': 'weapon_globals',
    '2fc317d15bfd12c3': 'cameraglobalsdefinition',
    '55fef13cef1de15e': 'cheatglobalsdefinition',
    '2c128bfef824d82e': 'colorglobalsdefinition',
    'c3d2119cd68289e3': 'controlglobalsdefinition',
    'fe48894dea87304e': 'inputscope',
    '0f836498203413ee': 'inputbundle',
    '666a88ae3b6d248e': 'inputmode',
    'e3682a86e61dca23': 'inputbundleset',
    '42c365e4bc1d1ab4': 'inputdevicebindings',
    '1e0cea713fa97ebc': 'damageglobalsdefinition',
    '50c0feb5c3fa4ce2': 'difficultyglobalsdefinition',
    'a7948fe731f9fd92': 'softceilingglobalsdefinition',
    'f4f222110b1ed98c': 'skullglobalsdefinition',
    '32dae3bb94f0f2e2': 'playerglobalsdefinition',
    'efbd2262595e9907': 'materialglobalsdefinition',
    '72864946671efdd0': 'water_physics_drag_properties',
    'ff0835b19fd55f90': 'locglobalsdefinition',
    '79665fadf4a19cec': 'interfaceglobalsdefinition',
    '21aa35f8b594c269': 'uicamerapresets',
    '17fe0b064b2f8a6c': 'forwardfastlighting',
    'e361ff1dae8ecb2c': 'uiiteminspect',
    'f86f8da079d0841f': 'uilightpresets',
    '4708998d2eb11041': 'uiobjectcustomization',
    'eced804e473b27e3': 'uiplatformanimations',
    '1f3e0e4d4fe84864': 'user_interface_shared_globals_definition',
    'e3d4ddfc0765a83e': 'bitmap_dictionary',
    'd0dd5b57ae95e15e': 'wpf_font_set',
    '3a651b2ae8c883e0': 'dispositioncolors',
    'df9ab328c6bdf7fd': 'typeface',
    'af178280e2930047': 'cui_resources',
    'bb45b4bd166b8c2b': 'user_interface_sounds_definition',
    '37789c1836d24447': 'emblem_theme_globals',
    '841a302bfad1a6e2': 'multilingual_unicode_string_list',
    'a5e78e7b971abf00': 'narrationphonemes',
    '143f74785d74db5c': 'damagereportingdisplayglobals',
    'fb3171ed1eb535a7': 'garbagecollectionglobalsdefinition',
    '8e2e45324dd70bea': 'gameplayobjectglobalsdefinition',
    '58df0867ad2727c1': 'composerglobalsdefinition',
    '21b828378163a2fe': 'skillrankingglobalsdefinition',
    '6726609fa3fb3fba': 'spartantrackingglobalsdefinition',
    'df6c9b6a4d11825f': 'outlineserviceglobalsdefinition',
    '922d938b5cf6ff98': 'asset_category_globals',
    'd191c92c4376203c': 'navigationglobals',
    'ce9d5c2346cf4e97': 'subtitleglobalsdefinition',
    'af91b9e609988c5e': 'actionprioritydatadefinitiontag',
    'f24ec6da0ea79486': 'highlightserviceglobalsdefinition',
    'eda04ceeb8182254': 'cageglobalsdefinition',
    '051e392fcc1da36c': 'audiothreatglobals',
    '335f95c5d84e5b40': 'animglobals',
    'd37155295b21a547': 'benchmarkdefinition',
    '97582572c32f7021': 'vectorart',
    '6e80e05aed4ad90a': 'flinch_impulse',
    '569d85c49b03c214': 'cheap_particle_type_library',
    '5be05c617fb816df': 'customizationattachmentconfiguration',
    '60e77e9a54d36809': 'wpf_font',
    'bf00514c99716177': 'customizationvehiclethemeconfiguration',
    '508bc55f041f373b': 'user_interface_globals_definition',
    '4792f2df2777e584': 'customizationweaponthemeconfiguration',
    'edaef7cf1dd5f315': 'effectoverride',
    '16b8e6da44950c24': 'sprintdefinitiontag',
    'f09407caec6a1869': 'uipersonalaisounds',
    'eb7581e0a4ada9e3': 'customizationthemeconfiguration',
    'd32800ab41d621ed': 'objectattachmentsdefinition',
    '69ac225102c1097c': 'materialvisorswatch',
    'dbce2d6d8de3121c': 'clamberingdefinition',
    '7c8e38f91d9d097f': 'propertybasedeffectstag',
    '887ed48b7b065982': 'flinch_system',
    '18aefaae2e2897de': 'lowceilingcontroltag',
    '7eaf0fb3a819196d': 'forgeobjectdata',
    '50688056a14f09f0': 'shieldupgrademetadata',
    'b2072458a1a77841': 'meleeadditionaldamage',
    'de601f604d0582d9': 'customizationglobalsdefinition',
    '7b51d3b7c9b3ed34': 'weaponcomponentaltfire',
    'd77f684581a71e09': 'uitransitionsounds',
    '5d59efec187f583e': 'user_interface_hud_globals_definition',
    '12a9b1938fb6b208': 'navpointanimationgroup',
    '6639c7d53f9985ae': 'navpointpresentation',
    'aec0f5cf65a8c741': 'cloth',
    '0e33eeb740444141': 'botglobalstag',
    '254077ffe939798b': 'airdropsystemglobalsdefinition',
    '42bb2327d69d6a0f': 'kit',
    '4bfdc48adb47feb7': 'trigger_volume_component',
    'ae578239fbc25f20': 'physics_phantom_sounds',
    'ee2260eb632b1796': 'sound_environment',
    '77f108f84411246b': 'uiseasondata',
    '3755d33210a80805': 'composer_spawning_pattern',
    '7b9db3259eebf64d': 'composer_transition',
    'a9709304fd24654a': 'forgeobjectmanifest',
    '02757851d8bff47e': 'rtmp',
    '9dbe60aff7f5b928': 'forgetelescopingasset',
    'df061a6f1299af68': 'forgekit',
    '61dc1fcacaf62fef': 'forgeobjectscriptpropertymenuitemdefinitions',
    '5a5b533af9f1e592': 'scenario_interpolator',
    'a5b2ea7daa4c55e6': 'level',
    'c1a1c700241d9946': 'scenario_structure_bsp',
    '71221116564974d5': 'bitmap',
    'fac399b9d2fef38a': 'soundbank',
    'f38b05a9a0992eba': 'runtime_geo',
    'c99547042e8f0f49': 'structure_lightmap',
    '01bb1db1e646f6df': 'shadervariant',
    '082263c691516f88': 'shader_bytecode',
    'd7d36bca0b19f887': 'psodictionary'
}

ma_guid_ext_resource = {
    '866fe37c76da2aab': ['resource_data'],
    '51f5b0b22475fcb8': ['string_list_resource'],
    'b8b51ce9966ad5d0': ['regions_resource'],
    '79d743c8ca034820': ['model_animation_resource'],
    '7deb4eccbe9aefa2': ['font_file_resource'],
    '1f6f971137966e5b': ['facial_animation_resource'],
    '9e6c7b4240fa3187': ['resource_data'],
    'b06da676339d3deb': ['legacy_bsp_kd_tree'],
    'c35a4c51ee160c29': ['tag_resources'],
    '83e10bc5509ed314': ['bitmap_resource_handle'],
    '75a4781e55634b12': ['sound_bank_sfx_resource', 'sound_bank_resource']
}

ma_guid_ext_no_magic = [
    'mesh_resource|render_model',
    'mesh_resource|runtime_geo',
    'bitmap_resource_handle|bitmap',
    'bitmap_resource_handle]|bitmap'
]
